mod digest;

use std::collections::HashMap;
use std::convert::Infallible;
use std::SocketAddr;
use serde_derive::{Deserialize, Serialize};
use warp::Filter;

#[tokio::main]
fn main() {
    let root = warp::path::end().map(|| "SecMonitor Master Server running...");

    let report = warp::post()
        .and(warp::path("report"))
        .and(warp::path::param::<u32>())
        .and(warp::body::json())
        .map(|project_id, mut stats: digest::Statistics| {
            digest::append_report_by_project(project_id, stats)
        });

    let routes = root.or(report);

    warp::serve(routes).run(([127, 0, 0, 1], 3456)).await;
}
